#!/usr/bin/python

# For each source file in GraphApp, compile it thus:
#  gcc -O2 -Wall -I. -Ietc -c -o objects/file.o subdir/file.c
# Then build the static library form of GraphApp, thus:
#  ar rc libapp.a objects/*.o
# Uses full paths.

print 'Compiling GraphApp'

import os, sys, string

project_base	=     '/home/loki/apps/app/'	# '/apps/app/'
source_base		= project_base + 'src/'
object_base		= source_base +       'objects/'
gcc_base		=    '/usr/'	# '/MinGW/'
gcc_inc			= gcc_base + 'include/'
gcc_bin			= gcc_base + 'bin/'
gcc				= gcc_bin +       'gcc'
make_static_lib	= gcc_bin +       'ar rc'
gcc_flags		= '-O2 -Wall'
gcc_compile		= '-c'
gcc_outfile		= '-o'
target_platform	= 'x11'	# 'win32'
static_lib		= source_base + 'libapp.a'
source_dirs		= [target_platform,
					'utility', 'gui',
					'libz', 'libpng', 'libjpeg', 'libgif', 'imgfmt',
					]
include_dirs	= ['.'] + source_dirs
verbose			= 1

def main():
	inc = ''
	for id in include_dirs:
		inc = inc + '-I' + source_base + id + ' '
	inc = inc + '-I' + gcc_inc
	for sd in source_dirs:
		files = os.listdir(source_base + sd)
		for file in files:
			if file[-2:] == '.c':
				compile(source_base + sd + '/', file[:-2], '.c', inc)

	build_static_lib()
				
def compile(filepath, name, ext, include_paths):
	cmd = gcc
	cmd = cmd + ' ' + gcc_flags
	cmd = cmd + ' ' + include_paths
	cmd = cmd + ' ' + gcc_compile
	cmd = cmd + ' ' + gcc_outfile + ' ' + object_base + name + '.o'
	cmd = cmd + ' ' + filepath + name + ext
	perform(cmd)

def build_static_lib():
	cmd = make_static_lib + ' ' + static_lib + ' ' + object_base + '*.o'
	perform(cmd)

def perform(cmd):
	if verbose:
		print cmd
	os.system(cmd)
	
if __name__ == '__main__':
	main()
